var initpage;
$(function () {
  showLoading();
  getZg();
})
// 获取重点税源资格
function getZg() {
  $.ajax({
    type: "post",
    url: config.url + "/online/zdsy/zg",
    dataType: "json", // 请求方式为jsonp
    // async: false,
    data: {
      djxh: getUrlParam("djxh"),
      token: getUrlParam("token"),
      nsrsbq: "",
    },
    success: function (data) {
      if (data.returnCode != '00') {
        hideLoading();
        myAlert("提示", data.returnMessage, "确定");
        return flase
      }
      var flag = data.content.flag;
      if (flag == 'Y') {
        getInitTable("")
      } else {
        alertWarning(data.content.message);
        hideLoading();
      }
    },
    error: function (xhr) {
      hideLoading();
      //jsonp 方式此方法不被触发
      console.log("=======error======================")
    }
  })
}
// 获取列表数据
function getInitTable(date) {
  $.ajax({
    type: "POST",
    url: config.url + "/online/zdsy/zdsyLb",
    dataType: "json", // 请求方式为jsonp
    // async: false,
    data: {
      djxh: getUrlParam("djxh"),
      nsrsbq: date,
    },
    success: function (data) { //客户端jquery预先定义好的callback函数，成功获取跨域服务器上的json数据后，会动态执行这个callback函数
      hideLoading();
      var companyInfo = data;
      if (companyInfo.returnCode == "00") {
        config.nsrsbq = companyInfo.content.nsrsbq
        config.value = companyInfo.content.value
        companyInfo.content.config = config
        companyInfo.content.return = true; /* @Author ygy @Date 10:12 2020/7/8 @Description 前端判断接口成功返回数据标记用于区分是否执行初始化table方法*/
        config.return = true;
        initpage = initPage(companyInfo.content);
        if (companyInfo.content.sdState == "Y") {
          $("#sdzt").html = "已锁定"
        } else {
          $("#sdzt").html = "未锁定"
        }
      } else {
        hideLoading();
        if (data.errmsg != undefined) {
          alertWarning(data.errmsg);
        } else {
          alertWarning(data.returnMessage);
        }
        if (!companyInfo.bean) {
          companyInfo.bean = {};
          companyInfo.bean.djxh = getUrlParam("djxh");
          companyInfo.bean.return = false;
        }
        companyInfo.bean.config = config
        initpage = initPage(companyInfo.bean);
        // 弹出错误对话框
      }
      $("#getInputValue").on("focus", function () {
        WdatePicker({
          isShowClear: false,
          dateFmt: 'yyyy-MM',
          onpicking: function (dp) {

            initpage.changeDate(this, dp);
          }
        });
      });
    },
    error: function (xhr) {
      hideLoading();
      //jsonp 方式此方法不被触发
      console.log("=======error======================")
    }
  })
}
var shBz = true; //重点税源审核标志

function initPage(companyInfo) {
  var companyInfo = companyInfo;
  var djxh = companyInfo.djxh;
  var nowdate = ""; // 存储当前选择的时间框;
  var submitData;

  var getSzLB = function (date) {
    showLoading();
    $.ajax({
      url: config.url + "/online/zdsy/zdsyLb",
      data: {
        djxh: djxh,
        nsrsbq: date,
      },
      type: "POST",
      dataType: "JSON",
    }).done(function (data) {
      companyInfo = data;
      if (data.returnCode == "00") {
        config.nsrsbq = data.content.nsrsbq
        config.value = data.content.value
        companyInfo.content.config = config
        companyInfo.content.return = true; /* @Author ygy @Date 10:12 2020/7/8 @Description 前端判断接口成功返回数据标记用于区分是否执行初始化table方法*/
        config.return = true;
        drawGrid(companyInfo.content);
      } else {
        if (data.errmsg != undefined) {
          alertWarning(data.errmsg);
        } else {
          alertWarning(data.returnMessage);
        }
      }
      hideLoading();
    }).always(function (data) {
      hideLoading();
    });
  }
  /**
   * 展示税种申报信息
   */
  var showTax = function (taxInfo) {
    if (taxInfo.length > 0) {
      var shNum = 0;
      for (var i = 0; i < taxInfo.length; i++) {
        if (taxInfo[i].state == 'Y') {
          shNum += 1
        }
        if (taxInfo[i].sksssjq) {
          taxInfo[i].sssqQ = tool.formatDate(taxInfo[i].sksssjq.split(" ")[0]);
        }
        if (taxInfo[i].sksssjz) {
          taxInfo[i].sssqZ = tool.formatDate(taxInfo[i].sksssjz.split(" ")[0]);
        }
        switch (taxInfo[i].state) {
          case 'N':
            taxInfo[i].txzt = "未填写";
            break;
          case 'Y':
            taxInfo[i].txzt = "已填写";
            break;
          case 'W':
            taxInfo[i].txzt = "填写错误";
            break;
        }
      }
      if (taxInfo.length == shNum) {
        shBz = true;
      } else {
        shBz = false;
      }
    }
    var id = "#taxGrid";
    var buttonHtml = "填写报表";
    var order = ["bbMc", "sssqQ", "sssqZ", "txzt", "do"];
    var promptStatement = "";
    var headerList = [{
      name: "序号",
      width: "5%"
    }, {
      name: "申报表",
      width: "55%"
    }, {
      name: "税款所属期起",
      width: "10%"
    }, {
      name: "税款所属期止",
      width: "10%"
    }, {
      name: "填写状态",
      width: "10%"
    }, {
      name: "操作",
      width: "10%"
    }];
    //渲染表
    getTableDeclaration(id, order, headerList, taxInfo, buttonHtml, promptStatement)
  };
  /**
   * 税务申报table渲染
   * @param {*} id
   * @param {*} order
   * @param {*} headerList
   * @param {*} ddt
   * @param {*} buttonHtml
   */
  var getTableDeclaration = function (id, order, headerList, ddt, buttonHtml, promptStatement) {
    var tableObj = {
      id: id, //tabel父元素的id
      autoHeight: ddt.length > 0 ? 10 : "",
      containerWidth: "99%", //table占父元素的百分比
      autoHeight: ddt.length > 0 ? 10 : "", // 默认10行
      order: order, //数据按照什么顺序排序  1.do为是否保函操作 2.序号列会自动添加不需要写
      onlyId: "bbDm", //数据的唯一标识
      height: "320", //表格的高度
      buttonHeight: "", //表格的高度
      buttonHtml: buttonHtml, //按钮里的字
      headerList: headerList, //表头名字及占比，顺序与order对应
      promptStatement: promptStatement, // 没有数据时默认提示
      data: {
        page: "1",
        pageSize: ddt.length
      },
      jsonReady: ddt,
      callback: function (data, node) {
        var bbDmVersion = data.bbDm + '_' + data.versionNumber;
        data.nsrsbq = config.nsrsbq;
        var sbzjKbData = { // 税表组件 开表参数
          bbDmVersion: bbDmVersion,
          valueTakingMethod: "ajax", // 提取数据方式控制  ajax 请求后台  cache 取浏览器缓存  ""不许要请求后台   key值为allParam
          sksssjq: data.sksssjq,
          sksssjz: data.sksssjz,
          requestRarameters: data, // 这里是对象
          requestAddress: { // 提取数据方式控制为ajax 此节点必须存在
            selectSbbInfoAddress: "/online/zdsyData/selectSbbInfo", // 开表接口
            deleteSbbInfoAddress: "/online/zdsyData/deleteSbbInfo", // 删除接口
            // tbSbbInfoAddress: "/htftsolu/tbSbbInfo",//同步接口
            saveSbbInfoAddress: "/online/zdsyData/saveSbbInfo", //保存接口
            // downloadPDFAddress: "/htftsolu/downloadPDF",//下载PDF接口
            // customBtnAddress: "/htftsolu/tbYKJInfo",//同步外部平台数据接口
            // saveTaxFromExcetion: "/htftsolu/saveTaxFromExcetion"//报错记录接口
          }, //存放接口地址
          readOnly: false,
          getCshBtn: true,
          getBjBtn: true,
          returnBtn: true,
          pdfBtn: false,
          printBtn: false,
          saveBtn: true,
          hideSaveData: '1', //用于其他平台隐藏式开表保存数据
          replaceBtn: false,
          deleteBtn: true,
          getOtherData: false,
          formSaveData: false,
          disableBtn: {
            disSave: false,
            disReplace: false
          },
          openMode: {
            flag: '3'
          }
        };
        data.sourceFlag = "zdsy"
        sbzjKbData.requestRarameters.nsrsbh = data.nsrsbh;
        sbzjKbData.requestRarameters.nsrsbq = data.nsrsbq;
        sbzjKbData.requestRarameters.saveUserId = data.sourceFlag;
        sbzjKbData.requestRarameters.getBjBz = 'init'
        window.open(config.taxFormComponent + JSON.stringify(sbzjKbData) + '&random=' + Math.random() + '#/' + bbDmVersion, '_blank');
      }
    };
    var object = tool.tableCreate(tableObj);
    //        object.jsonReadyTo(ddt, { page: "1", pageSize: ddt.length });
  };

  var drawGrid = function (bean) {
    if (bean.szlb.length == 0) {
      alertInfo("税费申报暂无数据");
    }
    showTax(bean.szlb);
  };

  // 格式化后台返回的时间
  if (companyInfo.config.return) {
    var year = companyInfo.nsrsbq.substring(0, 4);
    var month = companyInfo.nsrsbq.substring(4, 6);
    var sbq = year + '-' + month
    $("#getInputValue").val(sbq);
    nowdate = companyInfo.nsrsbq;
    drawGrid(companyInfo);
  }
  /**
   * 日期改变时触发
   * N 非强制刷新
   * @param {*} obj
   * @param {*} dp
   */
  var changeDate = function (obj, dp) {
    date = dp.cal.getNewDateStr();
    if(date!=""&&date!=undefined){
      nowdate = date.split('-')[0]+date.split('-')[1]; // 给缓存时间赋值
      // 加了一个延时，时间改变后时间框没有收起隐藏就加载数据，没有找到好的解决办法，暂时用延时处理
      setTimeout(function () {
        getSzLB(nowdate);
      }, 50);
    }
  };
  // 读取征管数据 点击事件
  var readDataF = function () {
    myConfirm("消息", "您确定需要读取征管数据吗？点击确定继续", "确定", "取消", function () {
      getTaxDeclaration(nowdate);
    });
  };
  $("#readData").on("click", readDataF);
  // 读取征管数据 接口调用
  var getTaxDeclaration = function (date) {
    // TODO 开始加载等待动画
    showLoading();
    $.ajax({
      url: config.url + "/online/zdsy/readData",
      data: {
        djxh: djxh,
        nsrsbq: date,
      },
      type: "POST",
      dataType: "JSON",
    }).done(function (data) {
      if (data.returnCode == "00") {
        alertSuccess(data.returnMessage);
      } else {
        if (data.errmsg != undefined) {
          alertWarning(data.errmsg);
        } else {
          alertWarning(data.returnMessage);
        }
      }
    }).always(function (data) {
      hideLoading();
    });
  };
  // 申报
  function declareTable() {
    console.log('declareTable')
  }
  $("#declareTable").on("click", declareTable);

  return {
    changeDate: changeDate,
    readDataF: readDataF,
  }
}
// 审核
function toExamineFun() {
  var html = "<div id='checkBJ'>表间校验</div>"
  // myAlert("提示", "允许审核", "确定");
  myCheck("审核校验", html, "确定", "取消", function () {
    // getTaxDeclaration(nowdate);
  });
};
$("#toExamine").on("click", function () {
  if (shBz) {
    toExamineFun()
  } else {
    myAlert("提示", "报表填写状态存在“未填写”或“填写错误”，请核对！", "确定");
  }
});